#include "../../ddk.h"

/*
 * global function
 */
GLOBAL_FUNCTION( jukebox_main )

typedef struct {
    unsigned short type;   //Type
    unsigned short stat;   //Status
    unsigned long  freq;   //Frequency Calculation Value
    unsigned long  loop;   //Loop Start Point
    unsigned long  size;   //Sampling Number
    char    data[1]; //Sampling Data Order
} WaveData;

/*
 * external data
 */
extern HANDLE			m_IntroTaskHandle;
extern const WaveData	_binary_drivershigh_raw_start;


//////////////////////////////////////////////////////////////////////////////////////////
static
VOID
PlayMusic(
	IN	char			*pSoundData
	)
{ 
	GBA_SND_REG_CNT0_L		= 0;
	GBA_SND_REG_CNT0_H		= 0x0b0F;
	GBA_SND_REG_CNT1		= 0x0080;

	GBA_DMA_REG_DM1SAD		= (ULONG)pSoundData;
	GBA_DMA_REG_DM1DAD		= 0x40000A0;
	GBA_DMA_REG_DM1CNT_H	= 0xb600;	
	
	GBA_TMR_REG_TM0D		= 64785; // 22050Hz
	GBA_TMR_REG_TM0CNT		= GBA_TMR_ENABLE; 		
}

static
VOID
StopMusic(VOID)
{
	GBA_DMA_REG_DM1CNT_H	= 0;
	GBA_SND_REG_CNT1		= 0;
	GBA_TMR_REG_TM0CNT		= 0;
}

//////////////////////////////////////////////////////////////////////////////////////////
VOID
jukebox_main(PVOID pContext)
{
	UCHAR	r_color=255;
	
	// wait intro task
	KeWaitForSingleObject( m_IntroTaskHandle, INFINITE );
	
	//
	while(1)
	{
		ULONG	end_tick;
		
		// play
		StopMusic();
		PlayMusic( (char*)_binary_drivershigh_raw_start.data );
		
		// effect!
		end_tick = KeQueryTickCount()+243000;
		for( ; end_tick>KeQueryTickCount(); r_color-- )
		{
			// print
			DbgColorPrintXY(
				RGB(255,255,255),
				RGB(r_color,0,0),
				" Driver's High  [GTO Opening] ",
				0,
				9
				);
			KeSleep(100);
		}
	}
}
