#ifndef _KERNEL_OBJECTS_DEFINITION_HEADER_FILE_
#define _KERNEL_OBJECTS_DEFINITION_HEADER_FILE_


/*
 * definitions
 */
typedef struct _LIST_ENTRY {
	struct _LIST_ENTRY			*Flink;
	struct _LIST_ENTRY			*Blink;
} LIST_ENTRY, *PLIST_ENTRY;


/*
 * dispatcher header
 */
#define DpcGetObjectByWaitList(pt_entry)		\
	(PDISPATCHER_HEADER)((ULONG)pt_entry - (ULONG)(&((PDISPATCHER_HEADER)0)->wait_list))
	
#define DpcGetObjectByWaitObjList(pt_entry)		\
	(PDISPATCHER_HEADER)((ULONG)pt_entry - (ULONG)(&((PDISPATCHER_HEADER)0)->waitobj_list))

typedef struct _DISPATCHER_HEADER {
	ULONG						signature;
	ULONG						signal_state;
	LIST_ENTRY					waitobj_list; // obj - obj - obj - ...
	LIST_ENTRY					wait_list; // task - task - task - ...
} DISPATCHER_HEADER, *PDISPATCHER_HEADER;


/*
 * task object
 */
#define TCB_SIGNATURE			'task'


/*
 * mutex object
 */
#define KMUTEX_SIGNATURE		'mutx'
 
typedef struct _KMUTEX {
	DISPATCHER_HEADER			header;
} KMUTEX, *PKMUTEX;


/*
 * semaphore object
 */
#define KSEMAPHORE_SIGNATURE	'smph'

typedef struct _KSEMAPHORE {
	DISPATCHER_HEADER			header;
	ULONG						count;
	ULONG						limit;
} KSEMAPHORE, *PKSEMAPHORE;


/*
 * event object
 */
#define KEVENT_SIGNATURE		'evnt'

typedef ULONG					KEVENT_TYPE;
#define NotificationEvent		0
#define SynchronizationEvent	1

typedef struct _KEVENT {
	DISPATCHER_HEADER			header;
	KEVENT_TYPE					type;
} KEVENT, *PKEVENT;


/*
 * timer object
 */
#define KTIMER_SIGNATURE		'tmr '

#define INFINITE				0xffffffff

typedef struct _KTIMER {
	DISPATCHER_HEADER			header;
	ULONG						timeout;
} KTIMER, *PKTIMER;


#endif /* #ifndef _KERNEL_OBJECTS_DEFINITION_HEADER_FILE_ */
