#include "ddk.h"

/*
 * global functions
 */
extern KERNELAPI BOOL TmStartMultiTasking(VOID);

/*
 * external functions
 */
extern KERNELAPI BOOL KrnInitializeModule(VOID);
//
extern VOID jukebox_main(PVOID);
extern VOID snake_main(PVOID);

/*
 * variables
 */
HANDLE	m_IntroTaskHandle;

//////////////////////////////////////////////////////////////////////////////////////////
static
VOID
intro_task_main(PVOID pContext)
{
	do
	{
		DbgColorPrint(
			RGB(255, 0, 0),
			RGB(0,0,0),
			"   Welcome to GMC WORLD! ;)   "
			);
		DbgPrint(
			"\n"
			"gmc type___ : snake + jukebox\n"
			"kernel ver_ : 1.0\n"
			"release____ : Oct. 4th, 2005.\n"
			"developer__ : Yeori\n"
			"e-mail_____ \n"
			"  alphamcu@hanmail.net\n"
			"homepage___ : www.zap.pe.kr\n"
			"\n"
			"press a key to continue..."
			);
			
		while( GBA_KEY_REG_FLAG & 0x01 ) ;
	} while(FALSE);
}

//////////////////////////////////////////////////////////////////////////////////////////
int
main()
{
    BOOL	result;
    
    // init
    m_IntroTaskHandle = NULL;

    // set video mode for Debugging Environments
    DbgSetDebugVideoMode();

    // initialize Kernel
    result = KrnInitializeModule();
    if( !result )
    {
        goto $kernel_error;
    }
    
    // create tasks
	TmCreateTask( 0, jukebox_main, NULL, FALSE );
	TmCreateTask( 0, snake_main, NULL, FALSE );
	
	// create intro task
	m_IntroTaskHandle = TmCreateTask( 0, intro_task_main, NULL, FALSE );

	// start multi-tasking!
	TmStartMultiTasking();

    // endless loop!
$kernel_error:
	while(1)
	{
	    DbgPrint("o_o");
	}

    return 0x6675636b;
}

