#include "ddk.h"


//////////////////////////////////////////////////////////////////////////////////////////
KERNELAPI
VOID
RtlInitializeList(
	IN	PLIST_ENTRY						pList
	)
{
	pList->Flink = pList;
	pList->Blink = pList;
}

KERNELAPI
ULONG
RtlGetListCount(
	IN	PLIST_ENTRY						pList
	)
{
	PLIST_ENTRY		pt_entry = pList;
	ULONG			count = 0;

	if( !pList ) { return 0; }

	while( pt_entry->Flink != pList )
	{
		count++;
		pt_entry = pt_entry->Flink;
	}

	return count;
}

KERNELAPI
VOID
RtlInsertToListHead(
	IN	PLIST_ENTRY						pList,
	IN	PLIST_ENTRY						pEntry
	)
{
	pEntry->Flink		= pList->Flink;
	pEntry->Blink		= pList;
	pList->Flink->Blink	= pEntry;
	pList->Flink		= pEntry;
}

KERNELAPI
VOID
RtlInsertToListTail(
	IN	PLIST_ENTRY						pList,
	IN	PLIST_ENTRY						pEntry
	)
{
	RtlInsertToListHead( pList->Blink, pEntry );
}

KERNELAPI
VOID
RtlRemoveEntryFromList(
	IN	PLIST_ENTRY						pEntry
	)
{
	pEntry->Blink->Flink	= pEntry->Flink;
	pEntry->Flink->Blink	= pEntry->Blink;
	pEntry->Flink			= pEntry;
	pEntry->Blink			= pEntry;
}
