	.text
	.arm
	.align
	
	@ definition
TOS_IRQ = 0x03007000
TOS_SVC = 0x03005000

	@ global functions
	.globl	TmpTaskContextSwitch
	.globl	TmCallIrqScheduler
	
	
@
@ called by HalpIrqHandler
@
TmCallIrqScheduler:
	stmfd	sp, {sp, lr}^
	sub		sp, sp, #8
	ldmfd	sp!, {r0, r1}	@ r0 = user_sp, r1 = user_lr

	sub     r0, r0, #4      
	sub     r2, r0, #24

	@ copy 6 words from IRQ stack to USER stack (r0-r3, r12, lr)
copy_stack:
	ldmfd   sp!, {r3}
	stmfa   r2!, {r3}
	cmp     r0, r2
	bne     copy_stack

	sub     r0, r0, #20     @ adjust the USER stack point
        
	stmfd	r0!, {r4-r11}	@ push r4-r11 onto the USER stack
	stmfd	r0!, {r1}		@ push the user_lr onto the USER stack
       
	mrs		r1, spsr
	stmfd	r0!, {r1}

ready_for_new_task:
	b		TmIrqScheduler


@ --------------------------------------------------
@ VOID TmpTaskContextSwitch(
@	IN	ULONG		StackCurrent
@ 	);
@
@ calling mode = irq
@
@ r0 = StackCurrent
@ --------------------------------------------------
TmpTaskContextSwitch:
	@ set stack pointer
	mov		sp, r0
	
	@ pop cpsr_usr value
	ldmfd	sp!, {r0}
	msr		spsr, r0
	
	@ pop lr_usr value
	ldmfd	sp, {lr}^
	nop					@ writing to banked register, requried 1 cycle more.
	add		sp, sp, #4
	
	@ pop registers for Context Switch
	ldmfd	sp!, {r4-r11}
	
	@ pop registers for IRQ
	ldmfd	sp!, {r0-r3, r12, lr}
	
	@ set sp_usr value
	stmfd	sp, {sp}
	sub		sp, sp, #4
	ldmfd	sp, {sp}^
	nop					@ writing to banked register, requried 1 cycle more.
	
	@ check current mode & restore stack pointer
	mrs		sp, cpsr
	ands	sp, sp, #0x01	@ irq=10010, svc=10011
	ldreq	sp, =TOS_IRQ
	ldrne	sp, =TOS_SVC
	@ ldr		sp, =TOS_IRQ
	
	@ switch!!
	movs	pc, lr

